// Copyright (C) 2001,2002 Krzysztof Drewicz <hunter@pld-linux.org>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version. See <URL:http://www.gnu.org/copyleft/gpl.html>
// for a copy.
// 

// Simple client for mks32 (http://www.mks.com.pl)

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <errno.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/times.h>
#include <sys/param.h>
#include <arpa/inet.h>


#include "mks.h"

void
err(char *msg, int code)
{
    perror(msg);
    perror(strerror(errno));
    exit(-code);
}

int zrob_ladny_komunikat (output, realname, iledwukropkowmamzjesc)
		char	*output,*realname;
		int iledwukropkowmamzjesc;
{
    char tmp[10];
    char            s[MAXBUFF],t[MAXBUFF];
	
	strcpy(s,	realname);
	strcpy(t,	output);
    bzero(tmp,10);
    sprintf(tmp,":");
    strtok(t, tmp);
	for(; iledwukropkowmamzjesc>0;iledwukropkowmamzjesc--)
	   sprintf(t,"%s", strtok( NULL, tmp)); // mniam
#ifdef OLDMKS32
	sprintf(output+(strlen(output)-strlen(t)),"%s%s",realname,t+TMP_NAME_LEN);
#elif defined(NEWMKS)
	sprintf(output+(strlen(output)-strlen(t)),"%s",t);
#endif
	return 0;
}

int open_socket (char* target ,FILE** fifo)
{				
	int				sockfd;
	struct sockaddr_in serv_addr;
	char		addr[128];
		
//		memset(s, MAXBUFF, 0);
		bzero(&addr, sizeof(addr));
		sprintf(addr, "%s", target);
		bzero((char *) &serv_addr, sizeof(serv_addr));
		serv_addr.sin_family = AF_INET;
		serv_addr.sin_addr.s_addr = inet_addr(addr);
		serv_addr.sin_port = htons(SERV_PORT);

		if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		    return -1;
		if (connect
		    (sockfd, (struct sockaddr *) &serv_addr,
		     sizeof(serv_addr)) < 0) {
		    return -2;
		};
		(*fifo) = fdopen(sockfd, "r+");
		return 0;
}

int mksc_check_filename(char *co_sprawdzac,char *output)
{
		char			s[MAXBUFF],t[MAXBUFF];
		int				i,
						flag=0;
		struct stat buf;
		FILE		*m_fifo,
					*tmp;

		open_socket("127.0.0.1", &m_fifo);
	    
		if ((tmp = fopen(co_sprawdzac, "r")) == NULL)
            {
		    perror("mksc_check_filename:");
          	//  perror(co_sprawdzac);
      		//  perror(strerror(errno));
            return -1;
            }

		stat(co_sprawdzac, &buf);
	
		if ((! S_ISDIR(buf.st_mode)) && (buf.st_size) > 0 ) {
			fprintf(m_fifo, "%d\n", buf.st_size);
			while (!feof(tmp)) {
			    fputc(fgetc(tmp), m_fifo);
			}
			fflush(m_fifo);
			fclose(tmp);
#ifdef OLDMKS32
#warning Old mks32 interface used. Be warned.
			fgets(s, MAXBUFF - 1, m_fifo);
			if JEST_WIRUS(s) flag=1;
			zrob_ladny_komunikat(s,co_sprawdzac,2);
			fgets(t, MAXBUFF - 1, m_fifo);
			zrob_ladny_komunikat(t,co_sprawdzac,3);
			strcpy(output,s);
			strcpy(output+strlen(s),t);
#elif defined(NEWMKS)
			fgets(s, MAXBUFF - 1, m_fifo);
			fgets(s, MAXBUFF - 1, m_fifo);
//			if JEST_WIRUS(s) flag=1;
			//zrob_ladny_komunikat(s,co_sprawdzac,2); // zjadamy jeden :
			strcpy(output,s+8);
			fgets(t, MAXBUFF - 1, m_fifo);
            if JEST_WIRUS_D(t) {
                        flag=1;
                        fgets(s, MAXBUFF - 1, m_fifo);
            }
			//printf("%s",t);
			//printf("eof\n");
			//zrob_ladny_komunikat(t,co_sprawdzac,1);
			//strcpy(output+strlen(s),t);
#endif            
			fclose(m_fifo);
			//close(sockfd);
		}				
    return flag;
}

int mks_status ()
{
			FILE* fifo;
			char	tmp[MAXBUFF];
			int i;
			
			if (0==(i=open_socket("127.0.0.1", &fifo))) {
				fprintf(fifo, "-7\n");

				for (i = 0; i<3; i++) {
					fgets(tmp, MAXBUFF - 1, fifo);	
					printf("%s", tmp);
					}
				fclose(fifo);
			return 0;
			}
			else 
				return i;	
		
}

int
main(int argc, char **argv)
{
	int     i,
        	wir=0,
					er=0,
					flag;
	char	out[MAXBUFF];

	if (argc==1)
			return mks_status();											
	else for (i = 1; i < argc; i++) 
					{
						mks_status();
						flag=mksc_check_filename(argv[i],out);
						if (flag==1)
							{
							wir=1;
							printf("%s: %s",argv[i],out);
							}
						if (flag==-1) er++;
					}									
	return wir;
}
// $Id: mks_c.c,v 1.3 2004/04/10 21:40:23 hunter Exp $
// vi:tw=78:ts=2:sw=4
